#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CHICKEN 8192
#define FLAG_INVALID 0
#define FLAG_CHICKEN 1

new UserFlags[33] = {FLAG_INVALID,...};
new UserOldName[33][MAX_NAME_LENGTH];
new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.0";

chicken_sound_1() {
  new i;
  new iMaxPlayers = maxplayercount();
  new Name[MAX_NAME_LENGTH];
  new UserID;
  new WONID;

  if (getvar("admin_fx") != 0) {
    for (i = 1; i <= iMaxPlayers; i++) {
  	if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
        playsound(Name, "sound/misc/chicken1");
      }
    }
  }
}

chicken_sound_2() {
  new i;
  new iMaxPlayers = maxplayercount();
  new Name[MAX_NAME_LENGTH];
  new UserID;
  new WONID;

  if (getvar("admin_fx") != 0) {
    for (i = 1; i <= iMaxPlayers; i++) {
  	if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
        playsound(Name, "sound/misc/chicken2");
      }
    }
  }
}

chicken_sound_3() {
  new i;
  new iMaxPlayers = maxplayercount();
  new Name[MAX_NAME_LENGTH];
  new UserID;
  new WONID;

  if (getvar("admin_fx") != 0) {
    for (i = 1; i <= iMaxPlayers; i++) {
  	if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
        playsound(Name, "sound/misc/chicken3");
      }
    }
  }
}

chicken_sound_4() {
  new i;
  new iMaxPlayers = maxplayercount();
  new Name[MAX_NAME_LENGTH];
  new UserID;
  new WONID;

  if (getvar("admin_fx") != 0) {
    for (i = 1; i <= iMaxPlayers; i++) {
  	if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
        playsound(Name, "sound/misc/chicken4");
      }
    }
  }
}


public admin_chicken(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new MyIndex;
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	get_username(Data,TargetName,MAX_NAME_LENGTH);
	get_userindex(TargetName,MyIndex);
	
	if (check_user(Data) == 1 && UserFlags[MyIndex] == FLAG_INVALID ) {
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		get_userindex(TargetName,MyIndex);

		say_command(User,Command,TargetName);
		
		UserFlags[MyIndex] = FLAG_CHICKEN;
		strcpy(UserOldName[MyIndex],TargetName,MAX_NAME_LENGTH);
		snprintf(ExecText, MAX_TEXT_LENGTH, "serv_chicken %i", MyIndex);
		exec(ExecText);
		execclient(TargetName, "name Chicken");
		chicken_sound_4();
		snprintf(Text, MAX_TEXT_LENGTH, "%s has been transformed into a chicken. FIND THE NUGGETS!", UserOldName[MyIndex]);
		typesay(Text, 10,255,25,2550);
		say(Text);
				
	} else {
		selfmessage("Already chicken or Unrecognized player.");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

public admin_unchicken(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new MyIndex;
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
			
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
		
	if ( check_user(Data) == 1 ) {
		
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		get_userindex(TargetName,MyIndex);

		say_command(User,Command,TargetName);
		
		if (strlen(UserOldName[MyIndex])!=0) {
			snprintf(Text, MAX_TEXT_LENGTH, "name ^"%s^"", UserOldName[MyIndex]);
			say(Text);
			execclient(TargetName, Text);
		} else {
			execclient(TargetName, "name NotAChicken");
		}
		snprintf(ExecText, MAX_TEXT_LENGTH, "serv_unchicken %i", MyIndex);
		exec(ExecText);
		snprintf(Text, MAX_TEXT_LENGTH, "%s has been restored to human form.", UserOldName[MyIndex]);
		typesay(Text, 10,255,25,255);
		say(Text);
		UserFlags[MyIndex] = FLAG_INVALID;
		
	} else {
		selfmessage("Unrecognized player: ");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}


public admin_chickenteam(HLCommand,HLData,HLUserName,UserIndex) {
  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new i;
  new maxplayers = maxplayercount();
  new SessionID;
  new WhichTeam;
  new TargetName[MAX_NAME_LENGTH];
  new Team;
  new ExecText[MAX_TEXT_LENGTH];
  new User[MAX_NAME_LENGTH];
  new WONID;
  new MyIndex;
  
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
  convert_string(HLData,Data,MAX_DATA_LENGTH);
  convert_string(HLUserName,User,MAX_NAME_LENGTH);

  WhichTeam = strtonum(Data);
	
  if(WhichTeam > 0 && WhichTeam < 3) {
    for(i=1; i<=maxplayers; i++) {
      strinit(TargetName);
      if(playerinfo(i,TargetName,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
	get_userindex(TargetName,MyIndex);
	say(TargetName);
	if( Team==WhichTeam && UserFlags[MyIndex] == FLAG_INVALID) {
	   UserFlags[MyIndex] = FLAG_CHICKEN;
           strcpy(UserOldName[MyIndex],TargetName,MAX_NAME_LENGTH);
	   snprintf(ExecText, MAX_TEXT_LENGTH, "serv_chicken %i", MyIndex);
	   exec(ExecText);
	   execclient(TargetName, "name Chicken");
	}
      }
    }
    log_command(User, Command, Data);
    typesay("TEAM Chicken", 10,255,25,2550);
    chicken_sound_4();
    
  } else {
    selfmessage("The team must be a number; 1 Terr, 2 CT");
  }
  return PLUGIN_HANDLED;
}


public admin_unchickenall(HLCommand,HLData,HLUserName,UserIndex) {
  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new i;
  new maxplayers = maxplayercount();
  new SessionID;
  new TargetName[MAX_NAME_LENGTH];
  new Team;
  new ExecText[MAX_TEXT_LENGTH];
  new User[MAX_NAME_LENGTH];
  new WONID;
  new MyIndex;
  
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
  convert_string(HLData,Data,MAX_DATA_LENGTH);
  convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
  
  for(i=1; i<=maxplayers; i++) {
    strinit(TargetName);
    strinit(ExecText);
    if(playerinfo(i,TargetName,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
      get_userindex(TargetName,MyIndex);
      if (UserFlags[MyIndex] == FLAG_CHICKEN) {
	UserFlags[MyIndex] = FLAG_INVALID;
	if (strlen(UserOldName[MyIndex])!=0) {
          snprintf(ExecText, MAX_TEXT_LENGTH, "name ^"%s^"", UserOldName[MyIndex]);
	  execclient(TargetName, ExecText);
	  say(ExecText);
	} else {
	  execclient(TargetName, "name NotAChicken");
	}
        snprintf(ExecText, MAX_TEXT_LENGTH, "serv_unchicken %i", MyIndex);
        exec(ExecText);
      }
    }
  }
	
  log_command(User, Command, Data);
  
  return PLUGIN_HANDLED;
}


public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];

	if (UserIndex == 0) {
		return PLUGIN_CONTINUE;
	}

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strstripquotes(Data);

	if (UserFlags[UserIndex] == FLAG_CHICKEN) {

		new Match = FALSE;						
		if(streq(Data,"buk buk")==1) {
			Match = TRUE;
		} else if (streq(Data, "buGAWK!")==1) {
			Match = TRUE;
		}
		
		if(Match==FALSE) {
			new ChickenMsg = random(4);
			if(ChickenMsg==0) {
				execclient(User, "say buk buk");
				chicken_sound_1();
			} else if (ChickenMsg==1) {
				execclient(User, "say buk buk");
				chicken_sound_2();
			} else if (ChickenMsg==2) {
				execclient(User, "say buk buk");
				chicken_sound_3();
			} else {
				execclient(User, "say buGAWK!");
				chicken_sound_4();
			}
			return PLUGIN_HANDLED;
		}		
	}
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserFlags[UserIndex] = FLAG_INVALID;
		strinit(UserOldName[UserIndex]);
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserFlags[UserIndex] = FLAG_INVALID;
		strinit(UserOldName[UserIndex]);
	}
	return PLUGIN_CONTINUE;
}

public plugin_info(HLOldName,HLNewName,UserIndex) {
	new NewName[MAX_NAME_LENGTH];
	new OldName[MAX_NAME_LENGTH];

	convert_string(HLNewName, NewName, MAX_NAME_LENGTH);
	convert_string(HLOldName, OldName, MAX_NAME_LENGTH);

	if(streq(OldName,NewName)==0) {
		if (UserFlags[UserIndex] == FLAG_CHICKEN) {
			execclient(OldName, "name Chicken");
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("Admin Chicken Plugin","interface for Chicken Mod.",STRING_VERSION);
	
	plugin_registercmd("admin_chicken","admin_chicken",ACCESS_CHICKEN,"admin_chicken <target>: Chicken-fy target.");
	plugin_registercmd("admin_unchicken","admin_unchicken",ACCESS_CHICKEN,"admin_unchicken <target>: Unchicken-fy target.");
	plugin_registercmd("admin_chickenteam","admin_chickenteam",ACCESS_CHICKEN,"admin_chickenteam <target>: Chicken-fy target.");
	plugin_registercmd("admin_unchickenall","admin_unchickenall",ACCESS_CHICKEN,"admin_unchickenall <target>: Unchicken-fy target.");
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registercmd("say_team","HandleSay",ACCESS_ALL);

	return PLUGIN_CONTINUE;	
}